'dllHost.bas
'
'Continuing from our discussion of ProgEx13 and dllMain.cpp, you should have
'ProgEx13.dll in your ProgEx13 directory, and this program - dllHost.bas, also
'there.  One way to successfully load and use this dll is to declare the
'exported function here in this file so that this program can load it at start
'up. This is referred to as implicit dynamic linking because if a declare
'references a dll, it is assummed the program will use that function somewhere
'in the code.  This is in contrast to explicit dynamic linking where you
'explicitly call LoadLibrary() (an Api function) to load a specific dll.
'
'In the PowerBASIC Help under 'Declare' you'll find all kinds of good info on
'the Declare statement, including what to do if an external function name
'clashes with a PowerBASIC reserved word such as the case here with 'Print'.
'Recall we named our exported dll function 'Print'.  Here we can easily drop a
'vowel and just call it by 'Prnt'.  With the Alias clause we inform the loader
'that 'Print' is the exported symbol it should look for.  When the dll was
'compiled a module definition file was created (libProgEx13.def) by the
'compile system and the exports are listed.  Here is the pertinent part of
'the above file when compiled with Dev-C++ and the GNU compiler...
'
'EXPORTS
'  Print @ 1
'
'This then becomes the symbol the loader will look for when this program is
'loaded.  Next program couple we'll look at what happens when the extern "C"
'specifier is not used in a C++ compiled dll.

#Compile Exe
#Dim All
Declare Sub Prnt Lib "ProgEx13.dll" Alias "Print" (Byref szMsg As Asciiz)

Function PBMain() As Long
  Call Prnt("Hello, World!")
  Waitkey$

  PBMain=0
End Function

'Output
'=============
'Hello, World!
